/*
** DON'T EDIT THIS FILE **
It's been generated by Zapatos, and is liable to be overwritten

Zapatos: https://jawj.github.io/zapatos/
Copyright (C) 2020 - 2022 George MacKerron
Released under the MIT licence: see LICENCE file
*/

declare module 'zapatos/schema' {
  import type * as db from 'zapatos/db'

  // got a type error on schemaVersionCanary below? update by running `npx zapatos`
  export interface schemaVersionCanary extends db.SchemaVersionCanary {
    version: 104
  }

  /* === schema: public === */

  /* --- enums --- */
  /* (none) */

  /* --- tables --- */

  /**
   * **category**
   * - Table in database
   */
  export namespace category {
    export type Table = 'category'
    export interface Selectable {
      /**
       * **category.id**
       * - `int4` in database
       * - `NOT NULL`, default: `nextval('category_id_seq'::regclass)`
       */
      id: number
      /**
       * **category.name**
       * - `text` in database
       * - `NOT NULL`, no default
       */
      name: string
      /**
       * **category.description**
       * - `text` in database
       * - Nullable, no default
       */
      description: string | null
    }
    export interface JSONSelectable {
      /**
       * **category.id**
       * - `int4` in database
       * - `NOT NULL`, default: `nextval('category_id_seq'::regclass)`
       */
      id: number
      /**
       * **category.name**
       * - `text` in database
       * - `NOT NULL`, no default
       */
      name: string
      /**
       * **category.description**
       * - `text` in database
       * - Nullable, no default
       */
      description: string | null
    }
    export interface Whereable {
      /**
       * **category.id**
       * - `int4` in database
       * - `NOT NULL`, default: `nextval('category_id_seq'::regclass)`
       */
      id?:
        | number
        | db.Parameter<number>
        | db.SQLFragment
        | db.ParentColumn
        | db.SQLFragment<
            any,
            number | db.Parameter<number> | db.SQLFragment | db.ParentColumn
          >
      /**
       * **category.name**
       * - `text` in database
       * - `NOT NULL`, no default
       */
      name?:
        | string
        | db.Parameter<string>
        | db.SQLFragment
        | db.ParentColumn
        | db.SQLFragment<
            any,
            string | db.Parameter<string> | db.SQLFragment | db.ParentColumn
          >
      /**
       * **category.description**
       * - `text` in database
       * - Nullable, no default
       */
      description?:
        | string
        | db.Parameter<string>
        | db.SQLFragment
        | db.ParentColumn
        | db.SQLFragment<
            any,
            string | db.Parameter<string> | db.SQLFragment | db.ParentColumn
          >
    }
    export interface Insertable {
      /**
       * **category.id**
       * - `int4` in database
       * - `NOT NULL`, default: `nextval('category_id_seq'::regclass)`
       */
      id?: number | db.Parameter<number> | db.DefaultType | db.SQLFragment
      /**
       * **category.name**
       * - `text` in database
       * - `NOT NULL`, no default
       */
      name: string | db.Parameter<string> | db.SQLFragment
      /**
       * **category.description**
       * - `text` in database
       * - Nullable, no default
       */
      description?:
        | string
        | db.Parameter<string>
        | null
        | db.DefaultType
        | db.SQLFragment
    }
    export interface Updatable {
      /**
       * **category.id**
       * - `int4` in database
       * - `NOT NULL`, default: `nextval('category_id_seq'::regclass)`
       */
      id?:
        | number
        | db.Parameter<number>
        | db.DefaultType
        | db.SQLFragment
        | db.SQLFragment<
            any,
            number | db.Parameter<number> | db.DefaultType | db.SQLFragment
          >
      /**
       * **category.name**
       * - `text` in database
       * - `NOT NULL`, no default
       */
      name?:
        | string
        | db.Parameter<string>
        | db.SQLFragment
        | db.SQLFragment<any, string | db.Parameter<string> | db.SQLFragment>
      /**
       * **category.description**
       * - `text` in database
       * - Nullable, no default
       */
      description?:
        | string
        | db.Parameter<string>
        | null
        | db.DefaultType
        | db.SQLFragment
        | db.SQLFragment<
            any,
            | string
            | db.Parameter<string>
            | null
            | db.DefaultType
            | db.SQLFragment
          >
    }
    export type UniqueIndex = 'category_name_key' | 'category_pkey'
    export type Column = keyof Selectable
    export type OnlyCols<T extends readonly Column[]> = Pick<
      Selectable,
      T[number]
    >
    export type SQLExpression =
      | Table
      | db.ColumnNames<Updatable | (keyof Updatable)[]>
      | db.ColumnValues<Updatable>
      | Whereable
      | Column
      | db.ParentColumn
      | db.GenericSQLExpression
    export type SQL = SQLExpression | SQLExpression[]
  }

  /**
   * **menu**
   * - Table in database
   */
  export namespace menu {
    export type Table = 'menu'
    export interface Selectable {
      /**
       * **menu.id**
       * - `int4` in database
       * - `NOT NULL`, default: `nextval('menu_id_seq'::regclass)`
       */
      id: number
      /**
       * **menu.name**
       * - `text` in database
       * - `NOT NULL`, no default
       */
      name: string
      /**
       * **menu.description**
       * - `text` in database
       * - Nullable, no default
       */
      description: string | null
      /**
       * **menu.price**
       * - `int4` in database
       * - `NOT NULL`, default: `0`
       */
      price: number
      /**
       * **menu.pic**
       * - `jsonb` in database
       * - Nullable, default: `'{}'::jsonb`
       */
      pic: db.JSONValue | null
      /**
       * **menu.status**
       * - `bool` in database
       * - `NOT NULL`, default: `false`
       */
      status: boolean
      /**
       * **menu.category_id**
       * - `int4` in database
       * - Nullable, no default
       */
      category_id: number | null
    }
    export interface JSONSelectable {
      /**
       * **menu.id**
       * - `int4` in database
       * - `NOT NULL`, default: `nextval('menu_id_seq'::regclass)`
       */
      id: number
      /**
       * **menu.name**
       * - `text` in database
       * - `NOT NULL`, no default
       */
      name: string
      /**
       * **menu.description**
       * - `text` in database
       * - Nullable, no default
       */
      description: string | null
      /**
       * **menu.price**
       * - `int4` in database
       * - `NOT NULL`, default: `0`
       */
      price: number
      /**
       * **menu.pic**
       * - `jsonb` in database
       * - Nullable, default: `'{}'::jsonb`
       */
      pic: db.JSONValue | null
      /**
       * **menu.status**
       * - `bool` in database
       * - `NOT NULL`, default: `false`
       */
      status: boolean
      /**
       * **menu.category_id**
       * - `int4` in database
       * - Nullable, no default
       */
      category_id: number | null
    }
    export interface Whereable {
      /**
       * **menu.id**
       * - `int4` in database
       * - `NOT NULL`, default: `nextval('menu_id_seq'::regclass)`
       */
      id?:
        | number
        | db.Parameter<number>
        | db.SQLFragment
        | db.ParentColumn
        | db.SQLFragment<
            any,
            number | db.Parameter<number> | db.SQLFragment | db.ParentColumn
          >
      /**
       * **menu.name**
       * - `text` in database
       * - `NOT NULL`, no default
       */
      name?:
        | string
        | db.Parameter<string>
        | db.SQLFragment
        | db.ParentColumn
        | db.SQLFragment<
            any,
            string | db.Parameter<string> | db.SQLFragment | db.ParentColumn
          >
      /**
       * **menu.description**
       * - `text` in database
       * - Nullable, no default
       */
      description?:
        | string
        | db.Parameter<string>
        | db.SQLFragment
        | db.ParentColumn
        | db.SQLFragment<
            any,
            string | db.Parameter<string> | db.SQLFragment | db.ParentColumn
          >
      /**
       * **menu.price**
       * - `int4` in database
       * - `NOT NULL`, default: `0`
       */
      price?:
        | number
        | db.Parameter<number>
        | db.SQLFragment
        | db.ParentColumn
        | db.SQLFragment<
            any,
            number | db.Parameter<number> | db.SQLFragment | db.ParentColumn
          >
      /**
       * **menu.pic**
       * - `jsonb` in database
       * - Nullable, default: `'{}'::jsonb`
       */
      pic?:
        | db.JSONValue
        | db.Parameter<db.JSONValue>
        | db.SQLFragment
        | db.ParentColumn
        | db.SQLFragment<
            any,
            | db.JSONValue
            | db.Parameter<db.JSONValue>
            | db.SQLFragment
            | db.ParentColumn
          >
      /**
       * **menu.status**
       * - `bool` in database
       * - `NOT NULL`, default: `false`
       */
      status?:
        | boolean
        | db.Parameter<boolean>
        | db.SQLFragment
        | db.ParentColumn
        | db.SQLFragment<
            any,
            boolean | db.Parameter<boolean> | db.SQLFragment | db.ParentColumn
          >
      /**
       * **menu.category_id**
       * - `int4` in database
       * - Nullable, no default
       */
      category_id?:
        | number
        | db.Parameter<number>
        | db.SQLFragment
        | db.ParentColumn
        | db.SQLFragment<
            any,
            number | db.Parameter<number> | db.SQLFragment | db.ParentColumn
          >
    }
    export interface Insertable {
      /**
       * **menu.id**
       * - `int4` in database
       * - `NOT NULL`, default: `nextval('menu_id_seq'::regclass)`
       */
      id?: number | db.Parameter<number> | db.DefaultType | db.SQLFragment
      /**
       * **menu.name**
       * - `text` in database
       * - `NOT NULL`, no default
       */
      name: string | db.Parameter<string> | db.SQLFragment
      /**
       * **menu.description**
       * - `text` in database
       * - Nullable, no default
       */
      description?:
        | string
        | db.Parameter<string>
        | null
        | db.DefaultType
        | db.SQLFragment
      /**
       * **menu.price**
       * - `int4` in database
       * - `NOT NULL`, default: `0`
       */
      price?: number | db.Parameter<number> | db.DefaultType | db.SQLFragment
      /**
       * **menu.pic**
       * - `jsonb` in database
       * - Nullable, default: `'{}'::jsonb`
       */
      pic?:
        | db.JSONValue
        | db.Parameter<db.JSONValue>
        | null
        | db.DefaultType
        | db.SQLFragment
      /**
       * **menu.status**
       * - `bool` in database
       * - `NOT NULL`, default: `false`
       */
      status?: boolean | db.Parameter<boolean> | db.DefaultType | db.SQLFragment
      /**
       * **menu.category_id**
       * - `int4` in database
       * - Nullable, no default
       */
      category_id?:
        | number
        | db.Parameter<number>
        | null
        | db.DefaultType
        | db.SQLFragment
    }
    export interface Updatable {
      /**
       * **menu.id**
       * - `int4` in database
       * - `NOT NULL`, default: `nextval('menu_id_seq'::regclass)`
       */
      id?:
        | number
        | db.Parameter<number>
        | db.DefaultType
        | db.SQLFragment
        | db.SQLFragment<
            any,
            number | db.Parameter<number> | db.DefaultType | db.SQLFragment
          >
      /**
       * **menu.name**
       * - `text` in database
       * - `NOT NULL`, no default
       */
      name?:
        | string
        | db.Parameter<string>
        | db.SQLFragment
        | db.SQLFragment<any, string | db.Parameter<string> | db.SQLFragment>
      /**
       * **menu.description**
       * - `text` in database
       * - Nullable, no default
       */
      description?:
        | string
        | db.Parameter<string>
        | null
        | db.DefaultType
        | db.SQLFragment
        | db.SQLFragment<
            any,
            | string
            | db.Parameter<string>
            | null
            | db.DefaultType
            | db.SQLFragment
          >
      /**
       * **menu.price**
       * - `int4` in database
       * - `NOT NULL`, default: `0`
       */
      price?:
        | number
        | db.Parameter<number>
        | db.DefaultType
        | db.SQLFragment
        | db.SQLFragment<
            any,
            number | db.Parameter<number> | db.DefaultType | db.SQLFragment
          >
      /**
       * **menu.pic**
       * - `jsonb` in database
       * - Nullable, default: `'{}'::jsonb`
       */
      pic?:
        | db.JSONValue
        | db.Parameter<db.JSONValue>
        | null
        | db.DefaultType
        | db.SQLFragment
        | db.SQLFragment<
            any,
            | db.JSONValue
            | db.Parameter<db.JSONValue>
            | null
            | db.DefaultType
            | db.SQLFragment
          >
      /**
       * **menu.status**
       * - `bool` in database
       * - `NOT NULL`, default: `false`
       */
      status?:
        | boolean
        | db.Parameter<boolean>
        | db.DefaultType
        | db.SQLFragment
        | db.SQLFragment<
            any,
            boolean | db.Parameter<boolean> | db.DefaultType | db.SQLFragment
          >
      /**
       * **menu.category_id**
       * - `int4` in database
       * - Nullable, no default
       */
      category_id?:
        | number
        | db.Parameter<number>
        | null
        | db.DefaultType
        | db.SQLFragment
        | db.SQLFragment<
            any,
            | number
            | db.Parameter<number>
            | null
            | db.DefaultType
            | db.SQLFragment
          >
    }
    export type UniqueIndex = 'menu_pkey'
    export type Column = keyof Selectable
    export type OnlyCols<T extends readonly Column[]> = Pick<
      Selectable,
      T[number]
    >
    export type SQLExpression =
      | Table
      | db.ColumnNames<Updatable | (keyof Updatable)[]>
      | db.ColumnValues<Updatable>
      | Whereable
      | Column
      | db.ParentColumn
      | db.GenericSQLExpression
    export type SQL = SQLExpression | SQLExpression[]
  }

  /**
   * **schema_migrations**
   * - Table in database
   */
  export namespace schema_migrations {
    export type Table = 'schema_migrations'
    export interface Selectable {
      /**
       * **schema_migrations.version**
       * - `varchar` in database
       * - `NOT NULL`, no default
       */
      version: string
    }
    export interface JSONSelectable {
      /**
       * **schema_migrations.version**
       * - `varchar` in database
       * - `NOT NULL`, no default
       */
      version: string
    }
    export interface Whereable {
      /**
       * **schema_migrations.version**
       * - `varchar` in database
       * - `NOT NULL`, no default
       */
      version?:
        | string
        | db.Parameter<string>
        | db.SQLFragment
        | db.ParentColumn
        | db.SQLFragment<
            any,
            string | db.Parameter<string> | db.SQLFragment | db.ParentColumn
          >
    }
    export interface Insertable {
      /**
       * **schema_migrations.version**
       * - `varchar` in database
       * - `NOT NULL`, no default
       */
      version: string | db.Parameter<string> | db.SQLFragment
    }
    export interface Updatable {
      /**
       * **schema_migrations.version**
       * - `varchar` in database
       * - `NOT NULL`, no default
       */
      version?:
        | string
        | db.Parameter<string>
        | db.SQLFragment
        | db.SQLFragment<any, string | db.Parameter<string> | db.SQLFragment>
    }
    export type UniqueIndex = 'schema_migrations_pkey'
    export type Column = keyof Selectable
    export type OnlyCols<T extends readonly Column[]> = Pick<
      Selectable,
      T[number]
    >
    export type SQLExpression =
      | Table
      | db.ColumnNames<Updatable | (keyof Updatable)[]>
      | db.ColumnValues<Updatable>
      | Whereable
      | Column
      | db.ParentColumn
      | db.GenericSQLExpression
    export type SQL = SQLExpression | SQLExpression[]
  }

  /* --- aggregate types --- */

  export namespace public {
    export type Table = category.Table | menu.Table | schema_migrations.Table
    export type Selectable =
      | category.Selectable
      | menu.Selectable
      | schema_migrations.Selectable
    export type JSONSelectable =
      | category.JSONSelectable
      | menu.JSONSelectable
      | schema_migrations.JSONSelectable
    export type Whereable =
      | category.Whereable
      | menu.Whereable
      | schema_migrations.Whereable
    export type Insertable =
      | category.Insertable
      | menu.Insertable
      | schema_migrations.Insertable
    export type Updatable =
      | category.Updatable
      | menu.Updatable
      | schema_migrations.Updatable
    export type UniqueIndex =
      | category.UniqueIndex
      | menu.UniqueIndex
      | schema_migrations.UniqueIndex
    export type Column =
      | category.Column
      | menu.Column
      | schema_migrations.Column

    export type AllBaseTables = [
      category.Table,
      menu.Table,
      schema_migrations.Table,
    ]
    export type AllForeignTables = []
    export type AllViews = []
    export type AllMaterializedViews = []
    export type AllTablesAndViews = [
      category.Table,
      menu.Table,
      schema_migrations.Table,
    ]
  }

  /* === global aggregate types === */

  export type Schema = 'public'
  export type Table = public.Table
  export type Selectable = public.Selectable
  export type JSONSelectable = public.JSONSelectable
  export type Whereable = public.Whereable
  export type Insertable = public.Insertable
  export type Updatable = public.Updatable
  export type UniqueIndex = public.UniqueIndex
  export type Column = public.Column

  export type AllSchemas = ['public']
  export type AllBaseTables = [...public.AllBaseTables]
  export type AllForeignTables = [...public.AllForeignTables]
  export type AllViews = [...public.AllViews]
  export type AllMaterializedViews = [...public.AllMaterializedViews]
  export type AllTablesAndViews = [...public.AllTablesAndViews]

  /* === lookups === */

  export type SelectableForTable<T extends Table> = {
    category: category.Selectable
    menu: menu.Selectable
    schema_migrations: schema_migrations.Selectable
  }[T]

  export type JSONSelectableForTable<T extends Table> = {
    category: category.JSONSelectable
    menu: menu.JSONSelectable
    schema_migrations: schema_migrations.JSONSelectable
  }[T]

  export type WhereableForTable<T extends Table> = {
    category: category.Whereable
    menu: menu.Whereable
    schema_migrations: schema_migrations.Whereable
  }[T]

  export type InsertableForTable<T extends Table> = {
    category: category.Insertable
    menu: menu.Insertable
    schema_migrations: schema_migrations.Insertable
  }[T]

  export type UpdatableForTable<T extends Table> = {
    category: category.Updatable
    menu: menu.Updatable
    schema_migrations: schema_migrations.Updatable
  }[T]

  export type UniqueIndexForTable<T extends Table> = {
    category: category.UniqueIndex
    menu: menu.UniqueIndex
    schema_migrations: schema_migrations.UniqueIndex
  }[T]

  export type ColumnForTable<T extends Table> = {
    category: category.Column
    menu: menu.Column
    schema_migrations: schema_migrations.Column
  }[T]

  export type SQLForTable<T extends Table> = {
    category: category.SQL
    menu: menu.SQL
    schema_migrations: schema_migrations.SQL
  }[T]
}
